#include <iostm8s103f3.h>
#include <intrinsics.h>
#include "define.h"
#include "znggen.h"
#include "dinind.h"

volatile uint tim1ms[coltim];  // 
uint TIMER,MTIME,INDEX;
volatile uchar RUN;
extern uchar timvhd[colvhd+1];    //  
extern uchar AZN[colraz+1];
#pragma location=0x4000 //  eeprom
__no_init uchar MSEC[450];
#pragma location=0x41C8 //  eepromh
__no_init uchar HOUR;
#pragma location=0x41D0 //  eeprom
__no_init uint MARKER;
 #pragma location=0x4803 //  eeprom (   - OPT)
__no_init uchar OPT2;
 #pragma location=0x4804 
__no_init uchar NOPT2;
uchar utst;

void ticsec (void);
void selind (void);
void settim (void);
void restim (void);
void init_time (void);
uchar readbin (uint i);
//////////////////////////////////////////////////////////////////
#pragma vector=TIM1_OVR_UIF_vector
__interrupt void TIM1OVR(void)
{
  timsec=1;
  TIM1_SR1_bit.UIF=0;// 
  //PB_ODR_bit.ODR5=~PB_ODR_bit.ODR5;
}
///////////////////////////////////////////////////////////////////
#pragma vector=TIM4_OVR_UIF_vector 
__interrupt void TIM4OVR(void)
{ uchar c;
  for(c=0;c<coltim;c++)
  {
    if(tim1ms[c]>1)tim1ms[c]--;
  }
  TIM4_SR_bit.UIF=0;// 
}
////////////////////////////////////////////////////////////////////////////////
void ticsec (void)
{
  uchar r;
  MTIME=(HOUR*3600)+(INDEX<<1)+readbin(INDEX);
   if(MTIME==MARKER)
     restim();
   else
   {
    r=~MSEC[INDEX];
      if(r<BIN8(10000000))r<<=1;
      else
      {
        r=1;
         MSEC[INDEX]=0xFF;
         while(ENDWREE==0);
          if(INDEX<449)INDEX++;
          else
          {
           INDEX=0;
           HOUR++;
           while(ENDWREE==0);
          }
      }
    MSEC[INDEX]=~r;
    while(ENDWREE==0);
   }
  timsec=0;
}
////////////////////////////////////////////////////////////////////////////////
void selind (void)
{
  uint time;
  uchar min,sec;
    if(RUN==0)time=TIMER;
    else
    {
      if(MARKER>MTIME)time=MARKER-MTIME;
      else time=MTIME-MARKER;
    }
  min=time/60;
  sec=time-(min*60);
   if(min>99) conv10_2(min,1);
   else if(min<10) conv10_2(((min*100)+sec),3);
   else conv10_2(((min*10)+(sec/10)),2); 
   timsin=251;
}
////////////////////////////////////////////////////////////////////////////////
void settim (void)
{
  MARKER=MTIME+TIMER;
  while(ENDWREE==0);
  TIM1_CNTRH=0;
  TIM1_CNTRL=250;
  TIM1_SR1_bit.UIF=0;
  TIM1_CR1_bit.CEN=1;       //  
  RUN=0xFF;
  TIMER=0;
}
////////////////////////////////////////////////////////////////////////////////
void restim (void)
{
  TIM1_CR1_bit.CEN=0;
  MARKER=MTIME;
  RUN=0;
}
////////////////////////////////////////////////////////////////////////////////
void init_time (void)
{
  INDEX=0;
   while(INDEX<450)
   {
     if(MSEC[INDEX]<0xFF) break;
     INDEX++;
   }
   if(INDEX==450){INDEX=0;MSEC[INDEX]=BIN8(11111110);}
   MTIME=(HOUR*3600)+(INDEX<<1)+readbin(INDEX);
   if(MTIME!=MARKER){RUN=0xFF;TIM1_CR1_bit.CEN=1;} 
}
////////////////////////////////////////////////////////////////////////////////
uchar readbin (uint i)
{
  uchar r,c=0;
 r=~MSEC[i]; 
  while(r>0)
  {
    r>>=1;
    c++;
  }
return c;
}
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
int main( void )
{
  
  FLASH_DUKR = 0xAE;//
  FLASH_DUKR = 0x56;// EEPROM and Options byte
  //FLASH_CR2_bit.OPT=1; //  Options byte
  //FLASH_NCR2_bit.NOPT=0; //  Options byte
  //OPT2|=(1<<0);
 // NOPT2&=~(1<<0); //C7 alternate function = TIM1_CH2.
  //FLASH_CR2_bit.OPT=0; //
  //FLASH_NCR2_bit.NOPT=1;
  CLK_PCKENR1=0;
  CLK_PCKENR2=0;
  // TIM1
  CLK_PCKENR1|=(1<<7);
  TIM1_CR1_bit.DIR=1; //down-counter
  TIM1_CR1_bit.ARPE=1;
  TIM1_ARRH=0;
  TIM1_ARRL=100;              //     10x100=1S
  TIM1_CNTRH=0;
  TIM1_CNTRL=100;
  TIM1_CCMR2_bit.CC2S=1;     //channel 2 to detect rising edges
  TIM1_CCMR2|=BIN8(01110000);//filter 7 takt
  TIM1_CCER1_bit.CC2P=0;     //rising edge polarity 
  TIM1_SMCR_bit.SMS=7;       //External clock source mode 1
  TIM1_SMCR_bit.TS=6;        //TI2 as the input source
  TIM1_IER_bit.UIE=1;       //    
 // TIM1_IER_bit.TIE=1;
  PC_CR1_bit.C17=1;
  TIM1_CR1_bit.CEN=1;       //  
  TIM1_SR1_bit.UIF=1;
        // TIM4
       CLK_PCKENR1|=(1<<4);//BIN8(00010000);
       TIM4_SR_bit.UIF=0;        //  
       TIM4_PSCR=0x03;           //  2^3=8  4uS (F_CPU=2000000)
       TIM4_CR1_bit.ARPE=1;
       TIM4_ARR=250;             //     1mS
       TIM4_IER_bit.UIE=1;       //    
       TIM4_CR1_bit.CEN=1;       //  
       TIM4_SR_bit.UIF=1;
 CPU_CFG_GCR_bit.SWD=1;  //SWIM->IO 
 //PB_DDR_bit.DDR5=1;
 //PB_CR1_bit.C15=1; 
  init_time();
  
  init_din();
  timdin=4;
  __enable_interrupt();
 conv10_2(123,1);

   //RRR(1);
  while(1)
  {  
   if(timdin==1)dinind();
    else if(timsec==1)
    {ticsec();}
    if(timsin==1)selind();
    else if(TKUD==TOPR)
    {restim();TKUD+=1;} 
    else if(TKSL==TOPR)
    {settim();TKSL+=1;}
    else if(RUN==0&&TKDW==TOPR&&TIMER<59940)
    {TIMER++;TKDW-=60;}//max 999min
    else if(RUN==0&&TKUP==TOPR&&TIMER<(59940-60))
    {TIMER+=60;TKUP-=60;}
  }
}
